## tellico 4.0

=== CMakeLists.txt ===
# FindPoppler requires CMake >= 3.16
cmake_minimum_required(VERSION 3.16 FATAL_ERROR)

project(Tellico)
set(TELLICO_VERSION "4.0")

if(DEFINED BUILD_WITH_QT6)
  set(GLOBAL_BUILD_WITH_QT6 ${BUILD_WITH_QT6})
endif()

find_package(ECM REQUIRED NO_MODULE)
# ECM uses the required version to determine whether to build with Qt6
# Instead, use the installed version and assume building with Qt6 unless
# BUILD_WITH_QT6=OFF was passed to cmake
if(NOT DEFINED GLOBAL_BUILD_WITH_QT6 AND
   ECM_VERSION VERSION_GREATER_EQUAL 5.240)
  option(BUILD_WITH_QT6 "Build against Qt 6" ON)
endif()

if(POLICY CMP0063)
  cmake_policy(SET CMP0063 NEW)
endif(POLICY CMP0063)

if(QT_MAJOR_VERSION STREQUAL "6")
  set(QT_MIN_VERSION "6.4.0")
  set(KF_MIN_VERSION "5.240.0")
  set(CMAKE_CXX_STANDARD 20)
else()
  set(QT_MIN_VERSION "5.12.0")
  set(KF_MIN_VERSION "5.72.0")
  set(CMAKE_CXX_STANDARD 17)
endif()

# https://gitlab.kitware.com/cmake/community/wikis/doc/cmake/Useful-Variables
# automatically add CMAKE_CURRENT_SOURCE_DIR and CMAKE_CURRENT_BINARY_DIR
# to the include directories in every processed CMakeLists.txt
set(CMAKE_INCLUDE_CURRENT_DIR TRUE)

set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH}
                      ${CMAKE_CURRENT_SOURCE_DIR}/cmake/modules
                      ${ECM_MODULE_PATH})

include(ECMAddAppIcon)
include(ECMUninstallTarget)
include(FeatureSummary)

include(KDEInstallDirs)
include(KDECompilerSettings NO_POLICY_SCOPE)
include(KDECMakeSettings)
set(CMAKE_C_EXTENSIONS OFF)
set(CMAKE_CXX_EXTENSIONS OFF)
set(CMAKE_CXX_STANDARD_REQUIRED TRUE)

############# Options #################

option(ENABLE_CDTEXT       "Enable cdtext" TRUE)
option(ENABLE_WEBCAM       "Enable support for webcams" FALSE)
option(BUILD_FETCHER_TESTS "Build tests which verify data sources" FALSE)
option(USE_KHTML           "Build with KHTML rather than QWebEngine" FALSE)
option(ENABLE_BTPARSE      "Build with bibtex importing using btparse, whether internal or external" TRUE)

# btparse does not compile with msvc
if(ENABLE_BTPARSE AND MSVC)
  set(ENABLE_BTPARSE FALSE)
endif()

include(CheckSymbolExists)
check_symbol_exists(strlwr "string.h" HAVE_STRLWR)
check_symbol_exists(strupr "string.h" HAVE_STRUPR)

find_package(Qt${QT_MAJOR_VERSION} ${QT_MIN_VERSION} CONFIG REQUIRED COMPONENTS
    Widgets
    Xml
    DBus
    Test
    Network
    PrintSupport
)

set(KF_MAJOR_VERSION ${QT_MAJOR_VERSION})
find_package(KF${KF_MAJOR_VERSION} REQUIRED COMPONENTS
    Archive
    Codecs
    Completion
    Config
    ConfigWidgets
    CoreAddons
    Crash
    DocTools
    GuiAddons
    IconThemes
    ItemModels
    I18n
    JobWidgets
    KIO
    Solid
    Sonnet
    TextWidgets
    WidgetsAddons
    XmlGui
)

if(NOT USE_KHTML)
  find_package(Qt${QT_MAJOR_VERSION} ${QT_MIN_VERSION} CONFIG OPTIONAL_COMPONENTS
    WebEngineWidgets
  )
  set_package_properties(Qt${QT_MAJOR_VERSION}WebEngineWidgets PROPERTIES
    DESCRIPTION "Building with QWebEngine is preferrable to KHTML"
    TYPE OPTIONAL)
endif()
if(USE_KHTML OR NOT Qt${QT_MAJOR_VERSION}WebEngineWidgets_FOUND)
  set(USE_KHTML ON)
  find_package(KF${KF_MAJOR_VERSION}KHtml REQUIRED NO_MODULE)
  set_package_properties(KF${KF_MAJOR_VERSION}Html PROPERTIES
    DESCRIPTION "Building with QWebEngine is preferrable to KHTML")
endif()

find_package(Qt${QT_MAJOR_VERSION} ${QT_MIN_VERSION} CONFIG OPTIONAL_COMPONENTS
  Charts
)

include(MacroBoolTo01)

find_package(Gettext REQUIRED)
find_package(LibXml2 REQUIRED)
find_package(LibXslt REQUIRED)

find_package(KF${KF_MAJOR_VERSION}FileMetaData)
set_package_properties(KF${KF_MAJOR_VERSION}FileMetaData PROPERTIES
    DESCRIPTION "Support for reading file metadata"
    URL "https://www.kde.org"
    TYPE OPTIONAL)

find_package(KF${KF_MAJOR_VERSION}NewStuff)
set_package_properties(KF${KF_MAJOR_VERSION}NewStuff PROPERTIES
    DESCRIPTION "Support for fetching new templates and scripts"
    URL "https://www.kde.org"
    TYPE OPTIONAL)

if (KF_MAJOR_VERSION STREQUAL "5")
    set(KSANE_TARGET_NAME KF5::Sane)
    find_package(KF5Sane)
else()
    set(KSANE_TARGET_NAME KSaneWidgets6)
    find_package(KSaneWidgets6)
endif()
set_package_properties(KSANE_TARGET_NAME PROPERTIES
    DESCRIPTION "Support for adding scanned images to a collection"
    URL "https://www.kde.org"
    TYPE OPTIONAL)

if (KF_MAJOR_VERSION STREQUAL "5")
    set(KCDDB_TARGET_NAME KF5::Cddb)
    find_package(KF5Cddb 5.1)
else()
    set(KCDDB_TARGET_NAME KCddb6)
    find_package(KCddb6 5.1)
endif()
set_package_properties(${KCDDB_TARGET_NAME} PROPERTIES
    DESCRIPTION "Support for CDDB searches"
    URL "https://invent.kde.org/multimedia/libkcddb"
    TYPE OPTIONAL)

find_package(Taglib)
if(TAGLIB_FOUND)
    if(TAGLIB_LIBRARIES)
        # Older taglib
        add_definitions(${TAGLIB_CFLAGS})
        include_directories(${TAGLIB_INCLUDES})
    else()
        set(TAGLIB_LIBRARIES Taglib::Taglib)
    endif()
endif(TAGLIB_FOUND)

find_package(Yaz 2.0)
set_package_properties(Yaz PROPERTIES
    DESCRIPTION "Support for searching z39.50 databases"
    URL "https://www.indexdata.com/resources/software/yaz/"
    TYPE OPTIONAL)
if(Yaz_FOUND)
    include_directories(${Yaz_INCLUDE_DIRS})
endif(Yaz_FOUND)

# FindPoppler is part of ECM >= 5.19
find_package(Poppler COMPONENTS Qt${QT_MAJOR_VERSION})

find_package(Exempi 2.0)
set_package_properties(Exempi PROPERTIES
    DESCRIPTION "Support for reading PDF/XMP metadata"
    URL "https://libopenraw.freedesktop.org/exempi/"
    TYPE OPTIONAL)
if(Exempi_FOUND)
    include_directories(${Exempi_INCLUDE_DIRS})
endif(Exempi_FOUND)

if(ENABLE_BTPARSE)
find_package(Btparse)
set_package_properties(Btparse PROPERTIES
    DESCRIPTION "External support for parsing and processing BibTeX data files"
    URL "https://metacpan.org/release/Text-BibTeX"
    TYPE OPTIONAL)
if(Btparse_FOUND)
    include_directories(${Btparse_INCLUDE_DIRS})
    set(TELLICO_BTPARSE_LIBS ${Btparse_LIBRARIES})
else(Btparse_FOUND)
    set(TELLICO_BTPARSE_LIBS btparse-tellico)
endif(Btparse_FOUND)
endif(ENABLE_BTPARSE)

find_package(CDIO)
set_package_properties(CDIO PROPERTIES
    DESCRIPTION "Support for reading cdtext from audio CDs"
    URL "https://www.gnu.org/software/libcdio/"
    TYPE OPTIONAL)
if(CDIO_FOUND)
    include_directories(${CDIO_INCLUDE_DIRS})
endif(CDIO_FOUND)

find_package(Csv 3.0)
set_package_properties(Csv PROPERTIES
    DESCRIPTION "External support for reading CSV files"
    URL "http://sourceforge.net/projects/libcsv/"
    TYPE OPTIONAL)
if(Csv_FOUND)
    include_directories(${Csv_INCLUDE_DIRS})
    set(TELLICO_CSV_LIBS ${Csv_LIBRARIES})
else(Csv_FOUND)
    set(TELLICO_CSV_LIBS csv-tellico)
endif(Csv_FOUND)

# webcam uses libv4l, which only works on Linux for now
# Linux 2.6.38 removed the videodev.h header
# libv4l 0.8.3 includes a compat header for videodev.h
if(ENABLE_WEBCAM)
    if(NOT CMAKE_SYSTEM_NAME MATCHES "Linux")
        message("WARNING: Webcam support is not available on your platform")
        set( ENABLE_WEBCAM FALSE )
    else(NOT CMAKE_SYSTEM_NAME MATCHES "Linux")
        pkg_check_modules(LIBV4L libv4l1>=0.6)
        #macro_log_feature(LIBV4L_FOUND "libv4l" "Support for barcode scanning with a webcam" "https://hansdegoede.livejournal.com/3636.html"  FALSE "" "")
        set_package_properties(LIBV4L PROPERTIES
            DESCRIPTION "Support for barcode scanning with a webcam"
            URL "https://hansdegoede.livejournal.com/3636.html"
            TYPE OPTIONAL)
        if(LIBV4L_FOUND)
            if(LIBV4L_VERSION VERSION_LESS "0.8.3" AND CMAKE_SYSTEM_VERSION VERSION_GREATER "2.6.37")
                message("WARNING: libv4l 0.8.3 or later is required for Linux kernel 2.6.38 or later")
                set( ENABLE_WEBCAM FALSE )
            else(LIBV4L_VERSION VERSION_LESS "0.8.3" AND CMAKE_SYSTEM_VERSION VERSION_GREATER "2.6.37")
                include_directories(${LIBV4L_INCLUDE_DIR})
            endif(LIBV4L_VERSION VERSION_LESS "0.8.3" AND CMAKE_SYSTEM_VERSION VERSION_GREATER "2.6.37")
        else(LIBV4L_FOUND)
            set(ENABLE_WEBCAM FALSE)
        endif(LIBV4L_FOUND)
    endif(NOT CMAKE_SYSTEM_NAME MATCHES "Linux")
endif(ENABLE_WEBCAM)

if(CMAKE_COMPILER_IS_GNUCXX)
#    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wnon-virtual-dtor -Wno-long-long -Wextra -fno-check-new -Woverloaded-virtual")
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wnon-virtual-dtor -Wno-long-long -fno-check-new -Woverloaded-virtual -Wno-deprecated -Wno-deprecated-declarations")
endif(CMAKE_COMPILER_IS_GNUCXX)

add_definitions(-DQT_STL -DQT_NO_CAST_FROM_ASCII -DQT_NO_URL_CAST_FROM_STRING -DQT_USE_QSTRINGBUILDER)
remove_definitions(-DQT_NO_STL)

include_directories(${LIBXML2_INCLUDE_DIR}
                    ${LIBXSLT_INCLUDE_DIR}
                    ${CMAKE_CURRENT_BINARY_DIR}
                    ${Tellico_SOURCE_DIR}/src/config
                    ${Tellico_SOURCE_DIR}/src/3rdparty)

set(TELLICO_DATA_INSTALL_DIR ${KDE_INSTALL_DATADIR}/tellico)

add_subdirectory(src)
add_subdirectory(icons)
add_subdirectory(xslt)
add_subdirectory(doc)

########## Wrap tests results around the tests done within the source

macro_bool_to_01(TAGLIB_FOUND HAVE_TAGLIB)
macro_bool_to_01(Poppler_Qt${QT_MAJOR_VERSION}_FOUND HAVE_POPPLER)
macro_bool_to_01(Exempi_FOUND HAVE_EXEMPI)
macro_bool_to_01(Yaz_FOUND HAVE_YAZ)
macro_bool_to_01(${KSANE_TARGET_NAME}_FOUND HAVE_KSANE)
macro_bool_to_01(Libkcddb_FOUND HAVE_OLD_KCDDB)
macro_bool_to_01(${KCDDB_TARGET_NAME}_FOUND HAVE_KCDDB)
macro_bool_to_01(KDEPIMLIBS_FOUND HAVE_KABC)
macro_bool_to_01(KDEPIMLIBS_FOUND HAVE_KCAL)
macro_bool_to_01(LIBV4L_FOUND HAVE_V4L)
macro_bool_to_01(KF${KF_MAJOR_VERSION}NewStuff_FOUND ENABLE_KNEWSTUFF3)
macro_bool_to_01(Btparse_FOUND HAVE_LIBBTPARSE)
macro_bool_to_01(CDIO_FOUND HAVE_CDIO)
macro_bool_to_01(Csv_FOUND HAVE_LIBCSV)
macro_bool_to_01(KF${KF_MAJOR_VERSION}FileMetaData_FOUND HAVE_KFILEMETADATA)
macro_bool_to_01(Qt${QT_MAJOR_VERSION}Charts_FOUND HAVE_QCHARTS)
macro_bool_to_01(ENABLE_BTPARSE ENABLE_BTPARSE)
macro_bool_to_01(BUILD_FETCHER_TESTS ENABLE_NETWORK_TESTS)

configure_file(${CMAKE_CURRENT_SOURCE_DIR}/config.h.cmake ${CMAKE_CURRENT_BINARY_DIR}/config.h)

########### install files ###############

install(PROGRAMS org.kde.tellico.desktop DESTINATION ${KDE_INSTALL_APPDIR})
install(FILES tellico.xml DESTINATION  ${KDE_INSTALL_MIMEDIR})
install(FILES org.kde.tellico.appdata.xml DESTINATION ${KDE_INSTALL_METAINFODIR} )
ki18n_install(po)
kdoctools_install(po)

feature_summary(WHAT ALL FATAL_ON_MISSING_REQUIRED_PACKAGES)

=== src/CMakeLists.txt ===
ADD_SUBDIRECTORY( core )
ADD_SUBDIRECTORY( config )
ADD_SUBDIRECTORY( gui )
ADD_SUBDIRECTORY( collections )
ADD_SUBDIRECTORY( images )
ADD_SUBDIRECTORY( translators )
ADD_SUBDIRECTORY( fetch )
ADD_SUBDIRECTORY( commands )
ADD_SUBDIRECTORY( cite )
ADD_SUBDIRECTORY( newstuff )
ADD_SUBDIRECTORY( models )
ADD_SUBDIRECTORY( utils )
ADD_SUBDIRECTORY( 3rdparty )

IF( Qt${QT_MAJOR_VERSION}Charts_FOUND )
  ADD_SUBDIRECTORY( charts )
ENDIF( Qt${QT_MAJOR_VERSION}Charts_FOUND )

IF( BUILD_TESTING )
  ADD_SUBDIRECTORY( tests )
ENDIF( BUILD_TESTING )

IF( ENABLE_WEBCAM )
  ADD_SUBDIRECTORY( barcode )
ENDIF( ENABLE_WEBCAM )

########### next target ###############

set(ICONS_PNG
  ${CMAKE_SOURCE_DIR}/icons/16-apps-tellico.png
  ${CMAKE_SOURCE_DIR}/icons/22-apps-tellico.png
  ${CMAKE_SOURCE_DIR}/icons/32-apps-tellico.png
  ${CMAKE_SOURCE_DIR}/icons/48-apps-tellico.png
  ${CMAKE_SOURCE_DIR}/icons/64-apps-tellico.png
  ${CMAKE_SOURCE_DIR}/icons/128-apps-tellico.png
)

ecm_add_app_icon(ICONS_SOURCES ICONS ${ICONS_PNG})

SET(tellico_SRCS
   ${ICONS_SOURCES}
   bibtexkeydialog.cpp
   borrower.cpp
   borrowerdialog.cpp
   collection.cpp
   collectionfactory.cpp
   collectionfieldsdialog.cpp
   configdialog.cpp
   controller.cpp
   dbusinterface.cpp
   detailedlistview.cpp
   derivedvalue.cpp
   document.cpp
   entry.cpp
   entryeditdialog.cpp
   entrygroup.cpp
   entryiconview.cpp
   entrycomparison.cpp
   entrymatchdialog.cpp
   entrymerger.cpp
   entryupdatejob.cpp
   entryupdater.cpp
   entryview.cpp
   exportdialog.cpp
   fetchdialog.cpp
   fetcherconfigdialog.cpp
   field.cpp
   fieldcompletion.cpp
   fieldformat.cpp
   filter.cpp
   filterdialog.cpp
   filterparser.cpp
   filterview.cpp
   groupview.cpp
   importdialog.cpp
   loandialog.cpp
   loanview.cpp
   main.cpp
   mainwindow.cpp
   printhandler.cpp
   progressmanager.cpp
   reportdialog.cpp
   tellico_debug.cpp
   tellico_kernel.cpp
   viewstack.cpp

   tellico.qrc
   )

add_executable(tellico ${tellico_SRCS} ../icons/icons.qrc)

TARGET_LINK_LIBRARIES(tellico
    core
    cite
    fetch
    collections
    images
    translators
    gui
    commands
    tellicomodels
    utils
    newstuff
    rtf2html-tellico
    ${TELLICO_BTPARSE_LIBS}
    ${TELLICO_CSV_LIBS}
    )

TARGET_LINK_LIBRARIES(tellico
    Qt${QT_MAJOR_VERSION}::Core
    Qt${QT_MAJOR_VERSION}::Widgets
    Qt${QT_MAJOR_VERSION}::DBus
    Qt${QT_MAJOR_VERSION}::PrintSupport
    KF${KF_MAJOR_VERSION}::Crash
    KF${KF_MAJOR_VERSION}::KIOCore
    KF${KF_MAJOR_VERSION}::KIOFileWidgets
    ${LIBXML2_LIBRARIES}
    ${LIBXSLT_LIBRARIES}
    ${LIBXSLT_EXSLT_LIBRARIES}
    )

IF( Qt${QT_MAJOR_VERSION}Charts_FOUND )
  TARGET_LINK_LIBRARIES(tellico charts)
ENDIF( Qt${QT_MAJOR_VERSION}Charts_FOUND )

IF(USE_KHTML)
  TARGET_LINK_LIBRARIES(tellico KF${KF_MAJOR_VERSION}::KHtml)
  ADD_DEFINITIONS(-DUSE_KHTML=${USE_KHTML})
ELSE()
  TARGET_LINK_LIBRARIES(tellico Qt${QT_MAJOR_VERSION}::WebEngineWidgets)
ENDIF()

IF( KF${KF_MAJOR_VERSION}NewStuff_FOUND )
  IF(KF${KF_MAJOR_VERSION}_VERSION VERSION_GREATER_EQUAL "5.91.0")
    TARGET_LINK_LIBRARIES(tellico KF${KF_MAJOR_VERSION}::NewStuffWidgets)
  ELSE()
    TARGET_LINK_LIBRARIES(tellico KF${KF_MAJOR_VERSION}::NewStuff)
  ENDIF()
ENDIF( KF${KF_MAJOR_VERSION}NewStuff_FOUND )

IF( KDEPIMLIBS_FOUND )
  TARGET_LINK_LIBRARIES(tellico KF${KF_MAJOR_VERSION}::Contacts ${KDEPIMLIBS_KCAL_LIBS} KF${KF_MAJOR_VERSION}::AkonadiContact)
ENDIF( KDEPIMLIBS_FOUND )

IF( ${KCDDB_TARGET_NAME}_FOUND )
  TARGET_LINK_LIBRARIES(tellico ${KCDDB_TARGET_NAME})
ELSEIF( Libkcddb_FOUND )
  TARGET_LINK_LIBRARIES(tellico KDE::Libkcddb::kcddb)
ENDIF( ${KCDDB_TARGET_NAME}_FOUND)

IF( Exempi_FOUND )
  TARGET_LINK_LIBRARIES(tellico ${Exempi_LIBRARIES})
ENDIF( Exempi_FOUND )

IF( TAGLIB_FOUND )
  TARGET_LINK_LIBRARIES(tellico ${TAGLIB_LIBRARIES})
ENDIF( TAGLIB_FOUND )

IF( Yaz_FOUND )
  TARGET_LINK_LIBRARIES(tellico ${Yaz_LIBRARIES})
ENDIF( Yaz_FOUND )

IF( ENABLE_WEBCAM )
  TARGET_LINK_LIBRARIES(tellico barcode ${LIBV4L_LIBRARIES})
ENDIF( ENABLE_WEBCAM )

IF( ${KSANE_TARGET_NAME}_FOUND )
  TARGET_LINK_LIBRARIES(tellico ${KSANE_TARGET_NAME})
ENDIF( ${KSANE_TARGET_NAME}_FOUND )

########### install files ###############

INSTALL(TARGETS tellico ${KDE_INSTALL_TARGETS_DEFAULT_ARGS} )
INSTALL(FILES tellicorc DESTINATION ${KDE_INSTALL_CONFDIR} )

=== src/barcode/CMakeLists.txt ===
########### next target ###############

SET(barcode_STAT_SRCS
   barcode.cpp
   barcode_v4l.cpp
   )

add_library(barcode STATIC ${barcode_STAT_SRCS})

TARGET_LINK_LIBRARIES(barcode
    Qt${QT_MAJOR_VERSION}::Core
    Qt${QT_MAJOR_VERSION}::Gui
)

=== src/charts/CMakeLists.txt ===
########### next target ###############

SET(charts_STAT_SRCS
   barchart.cpp
   chartmanager.cpp
   collectionsizereport.cpp
   groupsummaryreport.cpp
   yeardistributionreport.cpp
)

add_library(charts STATIC ${charts_STAT_SRCS})

target_link_libraries(charts
    tellicomodels
    Qt${QT_MAJOR_VERSION}::Charts
)

=== src/collections/CMakeLists.txt ===
########### next target ###############

SET(collections_STAT_SRCS
   bibtexcollection.cpp
   boardgamecollection.cpp
   bookcollection.cpp
   cardcollection.cpp
   coincollection.cpp
   collectioninitializer.cpp
   comicbookcollection.cpp
   filecatalog.cpp
   gamecollection.cpp
   musiccollection.cpp
   stampcollection.cpp
   videocollection.cpp
   winecollection.cpp
   )

add_library(collections STATIC ${collections_STAT_SRCS})

# bibtexcollection depends on utils/bibtexhandler
TARGET_LINK_LIBRARIES(collections utils Qt${QT_MAJOR_VERSION}::Core)

=== src/config/CMakeLists.txt ===
########### next target ###############

SET(config_STAT_SRCS
   tellico_config_addons.cpp
   )

SET(config_KCFG_SRCS
   tellico_config.kcfgc
   )

kconfig_add_kcfg_files(config_STAT_SRCS ${config_KCFG_SRCS})

ADD_CUSTOM_TARGET(tellico_config DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/tellico_config.h)

add_library(config STATIC ${config_STAT_SRCS})

TARGET_LINK_LIBRARIES(config
    Qt${QT_MAJOR_VERSION}::Core
    KF${KF_MAJOR_VERSION}::I18n
    KF${KF_MAJOR_VERSION}::ConfigCore
    KF${KF_MAJOR_VERSION}::ConfigGui
    KF${KF_MAJOR_VERSION}::ConfigWidgets
    )

########### install files ###############

INSTALL(FILES   tellico_config.kcfg DESTINATION ${KDE_INSTALL_KCFGDIR} )
INSTALL(FILES   tellico-rename.upd tellico.upd DESTINATION ${KDE_INSTALL_KCONFUPDATEDIR} )

INSTALL(PROGRAMS   tellico-1-3-update.pl tellico-3-4-update.pl DESTINATION ${KDE_INSTALL_KCONFUPDATEDIR} )

=== src/core/CMakeLists.txt ===
########### next target ###############

SET(core_STAT_SRCS
   filehandler.cpp
   logger.cpp
   netaccess.cpp
   tellico_strings.cpp
   )

add_library(core STATIC ${core_STAT_SRCS})

TARGET_LINK_LIBRARIES(core
    utils
    Qt${QT_MAJOR_VERSION}::Core
    Qt${QT_MAJOR_VERSION}::Xml
    KF${KF_MAJOR_VERSION}::I18n
    KF${KF_MAJOR_VERSION}::JobWidgets
    KF${KF_MAJOR_VERSION}::KIOWidgets
    )

=== src/newstuff/CMakeLists.txt ===
########### next target ###############

SET(newstuff_STAT_SRCS
   manager.cpp
   )

qt_add_dbus_adaptor(newstuff_STAT_SRCS org.kde.tellico.newstuff.xml manager.h Tellico::NewStuff::Manager)

add_library(newstuff STATIC ${newstuff_STAT_SRCS})

TARGET_LINK_LIBRARIES(newstuff
    utils
    Qt${QT_MAJOR_VERSION}::Core
    Qt${QT_MAJOR_VERSION}::Gui
    Qt${QT_MAJOR_VERSION}::DBus
    KF${KF_MAJOR_VERSION}::ConfigCore
    KF${KF_MAJOR_VERSION}::KIOCore
    KF${KF_MAJOR_VERSION}::Archive
    )

IF( KF${KF_MAJOR_VERSION}NewStuff_FOUND )
  if(${ECM_VERSION} VERSION_GREATER "5.57.0")
    INSTALL(FILES tellico-template.knsrc DESTINATION ${KDE_INSTALL_KNSRCDIR})
  else()
    INSTALL(FILES tellico-template.knsrc DESTINATION ${KDE_INSTALL_CONFDIR})
  endif()
endif()

=== src/tests/CMakeLists.txt ===
include(ECMAddTests)
include(ECMMarkNonGuiExecutable)

set(EXECUTABLE_OUTPUT_PATH ${CMAKE_CURRENT_BINARY_DIR})

# formattest includes fieldformat that include core/tellico_config.h
# which is generated in the build directory
include_directories(${Tellico_BINARY_DIR}/src)

ecm_add_test(entitytest.cpp ../fieldformat.cpp
    TEST_NAME entitytest
    LINK_LIBRARIES Qt${QT_MAJOR_VERSION}::Test utils config
)

ecm_add_test(comparisontest.cpp
    TEST_NAME comparisontest
    LINK_LIBRARIES Qt${QT_MAJOR_VERSION}::Test tellicotest tellicomodels
)

ecm_add_test(completiontest.cpp ../fieldcompletion.cpp ../field.cpp ../fieldformat.cpp
    TEST_NAME completiontest
    LINK_LIBRARIES Qt${QT_MAJOR_VERSION}::Test KF${KF_MAJOR_VERSION}::Completion utils config
)

ecm_add_test(cuecattest.cpp
    TEST_NAME cuecattest
    LINK_LIBRARIES Qt${QT_MAJOR_VERSION}::Test utils
)

ecm_add_test(isbntest.cpp
    TEST_NAME isbntest
    LINK_LIBRARIES Qt${QT_MAJOR_VERSION}::Test utils
)

ecm_add_test(lccntest.cpp
    TEST_NAME lccntest
    LINK_LIBRARIES Qt${QT_MAJOR_VERSION}::Test utils
)

ecm_add_test(lcctest.cpp ../field.cpp ../fieldformat.cpp ../tellico_debug.cpp
    TEST_NAME lcctest
    LINK_LIBRARIES Qt${QT_MAJOR_VERSION}::Test tellicomodels
)

ecm_add_test(formattest.cpp ../fieldformat.cpp
    TEST_NAME formattest
    LINK_LIBRARIES Qt${QT_MAJOR_VERSION}::Test config
)

ecm_add_test(fieldtest.cpp ../field.cpp ../fieldformat.cpp
    TEST_NAME fieldtest
    LINK_LIBRARIES Qt${QT_MAJOR_VERSION}::Test config utils
)

ecm_add_test(imagetest.cpp
             ../utils/tellico_utils.cpp
             ../utils/guiproxy.cpp
             ../utils/cursorsaver.cpp
             ../fieldformat.cpp
             ../tellico_debug.cpp
    TEST_NAME imagetest
    LINK_LIBRARIES Qt${QT_MAJOR_VERSION}::Test KF${KF_MAJOR_VERSION}::Archive images
)

ecm_add_test(imagejobtest.cpp ../fieldformat.cpp ../tellico_debug.cpp
    TEST_NAME imagejobtest
    LINK_LIBRARIES Qt${QT_MAJOR_VERSION}::Test  KF${KF_MAJOR_VERSION}::Archive images
)

ecm_add_test(iso6937test.cpp ../tellico_debug.cpp
    TEST_NAME iso6937test
    LINK_LIBRARIES Qt${QT_MAJOR_VERSION}::Test utils
)

ecm_add_test(iso5426test.cpp ../tellico_debug.cpp
    TEST_NAME iso5426test
    LINK_LIBRARIES Qt${QT_MAJOR_VERSION}::Test utils
)

ecm_add_test(newstufftest.cpp ../fieldformat.cpp ../tellico_debug.cpp
    TEST_NAME newstufftest
    LINK_LIBRARIES Qt${QT_MAJOR_VERSION}::Test newstuff config
)

ecm_add_test(rtftest.cpp
    TEST_NAME rtftest
    LINK_LIBRARIES Qt${QT_MAJOR_VERSION}::Test rtf2html-tellico
)

set(tellicotest_SRCS
    ../collection.cpp
    ../entry.cpp
    ../entrygroup.cpp
    ../entrycomparison.cpp
    ../field.cpp
    ../fieldformat.cpp
    ../filter.cpp
    ../borrower.cpp
    ../collectionfactory.cpp
    ../derivedvalue.cpp
    ../progressmanager.cpp
    ../tellico_debug.cpp
)

add_library(tellicotest STATIC ${tellicotest_SRCS})
target_link_libraries(tellicotest Qt${QT_MAJOR_VERSION}::Core Qt${QT_MAJOR_VERSION}::Gui KF${KF_MAJOR_VERSION}::I18n KF${KF_MAJOR_VERSION}::ConfigWidgets)

add_dependencies(tellicotest tellico_config)

set(translatorstest_SRCS
    ../translators/tellicoimporter.cpp
    ../translators/xsltimporter.cpp
    ../translators/textimporter.cpp
    ../translators/dataimporter.cpp
    ../translators/importer.cpp
    ../translators/tellicoxmlreader.cpp
    ../translators/tellico_xml.cpp
    ../translators/xmlstatehandler.cpp
    ../translators/xslthandler.cpp
)

add_library(translatorstest STATIC ${translatorstest_SRCS})
target_link_libraries(translatorstest
    Qt${QT_MAJOR_VERSION}::Core
    Qt${QT_MAJOR_VERSION}::Gui
    Qt${QT_MAJOR_VERSION}::Widgets
    Qt${QT_MAJOR_VERSION}::Xml
    KF${KF_MAJOR_VERSION}::I18n
    KF${KF_MAJOR_VERSION}::Archive
    KF${KF_MAJOR_VERSION}::KIOWidgets
    KF${KF_MAJOR_VERSION}::ConfigWidgets
    ${LIBXML2_LIBRARIES}
    ${LIBXSLT_LIBRARIES}
    ${LIBXSLT_EXSLT_LIBRARIES}
)

set(TELLICO_TEST_LIBS
    tellicotest
    collections
    utils
    images
    core
    tellicomodels
    Qt${QT_MAJOR_VERSION}::Test
    KF${KF_MAJOR_VERSION}::KIOCore
    KF${KF_MAJOR_VERSION}::Archive
)

ecm_add_test(collectiontest.cpp
             ../document.cpp
             ../utils/mergeconflictresolver.cpp
             ../translators/tellicoxmlexporter.cpp
             ../translators/tellicozipexporter.cpp
             ../translators/exporter.cpp
    TEST_NAME collectiontest
    LINK_LIBRARIES ${TELLICO_TEST_LIBS} translatorstest
)

ecm_add_test(commandtest.cpp
             ../commands/collectioncommand.cpp
             ../document.cpp
             ../translators/tellicoxmlexporter.cpp
             ../translators/tellicozipexporter.cpp
             ../translators/exporter.cpp
    TEST_NAME commandtest
    LINK_LIBRARIES translatorstest ${TELLICO_TEST_LIBS}
    # order of library linking here apparently matters
)

ecm_add_test(documenttest.cpp
             ../document.cpp
             ../translators/tellicoxmlexporter.cpp
             ../translators/tellicozipexporter.cpp
             ../translators/exporter.cpp
    TEST_NAME documenttest
    LINK_LIBRARIES ${TELLICO_TEST_LIBS} translatorstest
)

ecm_add_test(entrycomparisontest.cpp
    TEST_NAME entrycomparisontest
    LINK_LIBRARIES ${TELLICO_TEST_LIBS}
)

ecm_add_test(filtertest.cpp
             ../filter.cpp
             ../filterparser.cpp
    TEST_NAME filtertest
    LINK_LIBRARIES ${TELLICO_TEST_LIBS}
)

ecm_add_test(tellicomodeltest.cpp
             modeltest.cpp
             ../document.cpp
             ../translators/tellicoimporter.cpp
             ../translators/dataimporter.cpp
             ../translators/importer.cpp
             ../translators/tellicoxmlexporter.cpp
             ../translators/tellicozipexporter.cpp
             ../translators/exporter.cpp
             ../translators/tellicoxmlreader.cpp
             ../translators/tellico_xml.cpp
             ../translators/xmlstatehandler.cpp
    TEST_NAME tellicomodeltest
    LINK_LIBRARIES ${TELLICO_TEST_LIBS} ${LIBXML2_LIBRARIES}
)

######################################################

ecm_add_test(adstest.cpp
             ../translators/adsimporter.cpp
             ../translators/importer.cpp
    TEST_NAME adstest
    LINK_LIBRARIES ${TELLICO_TEST_LIBS}
)

ecm_add_test(alexandriatest.cpp
             ../translators/alexandriaimporter.cpp
             ../translators/importer.cpp
             ../translators/alexandriaexporter.cpp
             ../translators/exporter.cpp
    TEST_NAME alexandriatest
    LINK_LIBRARIES ${TELLICO_TEST_LIBS}
)

ecm_add_test(amctest.cpp
             ../translators/amcimporter.cpp
             ../translators/dataimporter.cpp
             ../translators/importer.cpp
    TEST_NAME amctest
    LINK_LIBRARIES ${TELLICO_TEST_LIBS}
)

if(TAGLIB_FOUND)
  ecm_add_test(audiofiletest.cpp
               ../translators/audiofileimporter.cpp
               ../translators/dataimporter.cpp
               ../translators/importer.cpp
      TEST_NAME audiofiletest
      LINK_LIBRARIES ${TELLICO_TEST_LIBS} ${TAGLIB_LIBRARIES}
  )
endif(TAGLIB_FOUND)

ecm_add_test(bibtextest.cpp
             ../translators/bibteximporter.cpp
             ../translators/importer.cpp
             ../translators/bibtexexporter.cpp
             ../translators/exporter.cpp
    TEST_NAME bibtextest
    LINK_LIBRARIES ${TELLICO_TEST_LIBS} ${TELLICO_BTPARSE_LIBS}
)

ecm_add_test(bibtexmltest.cpp
             ../translators/bibtexmlimporter.cpp
             ../translators/bibtexmlexporter.cpp
             ../translators/exporter.cpp
    TEST_NAME bibtexmltest
    LINK_LIBRARIES ${TELLICO_TEST_LIBS} translatorstest core
)

ecm_add_test(citetest.cpp
             ../collections/bibtexcollection.cpp
             ../core/filehandler.cpp
    TEST_NAME citetest
    LINK_LIBRARIES Qt${QT_MAJOR_VERSION}::Test cite tellicotest config images
)

ecm_add_test(ciwtest.cpp
             ../translators/ciwimporter.cpp
             ../translators/importer.cpp
    TEST_NAME ciwtest
    LINK_LIBRARIES ${TELLICO_TEST_LIBS}
)

ecm_add_test(collectorztest.cpp
             ../translators/collectorzimporter.cpp
    TEST_NAME collectorztest
    LINK_LIBRARIES ${TELLICO_TEST_LIBS} translatorstest
)

ecm_add_test(csvtest.cpp
             ../translators/csvparser.cpp
             ../translators/csvimporter.cpp
             ../translators/csvexporter.cpp
             ../translators/exporter.cpp
             ../gui/collectiontypecombo.cpp
             ../gui/combobox.cpp
             ../gui/listwidgetitem.cpp
             ../gui/stringmapwidget.cpp
             ../gui/stringmapdialog.cpp
             ../collectionfieldsdialog.cpp
    TEST_NAME csvtest
    LINK_LIBRARIES ${TELLICO_CSV_LIBS} ${TELLICO_TEST_LIBS} translatorstest
)

ecm_add_test(datacrowtest.cpp
             ../translators/datacrowimporter.cpp
    TEST_NAME datacrowtest
    LINK_LIBRARIES ${TELLICO_TEST_LIBS} translatorstest
)

ecm_add_test(delicioustest.cpp
             ../translators/deliciousimporter.cpp
    TEST_NAME delicioustest
    LINK_LIBRARIES ${TELLICO_TEST_LIBS} translatorstest rtf2html-tellico
)

ecm_add_test(discogstest.cpp
             ../translators/discogsimporter.cpp
    TEST_NAME discogstest
    LINK_LIBRARIES ${TELLICO_TEST_LIBS} translatorstest
)

ecm_add_test(fieldwidgettest.cpp
             ../gui/boolfieldwidget.cpp
             ../gui/checkablecombobox.cpp
             ../gui/choicefieldwidget.cpp
             ../gui/datefieldwidget.cpp
             ../gui/datewidget.cpp
             ../gui/spinbox.cpp
             ../gui/linefieldwidget.cpp
             ../gui/lineedit.cpp
             ../gui/numberfieldwidget.cpp
             ../gui/parafieldwidget.cpp
             ../gui/ratingwidget.cpp
             ../gui/ratingfieldwidget.cpp
             ../gui/tablefieldwidget.cpp
             ../gui/urlfieldwidget.cpp
             ../gui/fieldwidget.cpp
             ../document.cpp
             ../fieldcompletion.cpp
             ../translators/tellicoxmlexporter.cpp
             ../translators/tellicozipexporter.cpp
             ../translators/exporter.cpp
    TEST_NAME fieldwidgettest
    LINK_LIBRARIES translatorstest ${TELLICO_TEST_LIBS} KF${KF_MAJOR_VERSION}::XmlGui KF${KF_MAJOR_VERSION}::SonnetCore KF${KF_MAJOR_VERSION}::SonnetUi KF${KF_MAJOR_VERSION}::TextWidgets
)

ecm_add_test(filelistingtest.cpp
             ../translators/filelistingimporter.cpp
             ../translators/filereader.cpp
             ../translators/filereaderbook.cpp
             ../translators/filereadervideo.cpp
             ../translators/xmphandler.cpp
             ../gui/collectiontypecombo.cpp
             ../gui/combobox.cpp
    TEST_NAME filelistingtest
    LINK_LIBRARIES translatorstest ${TELLICO_TEST_LIBS} KF${KF_MAJOR_VERSION}::Solid #order of libs here is important
)
if(KF${KF_MAJOR_VERSION}FileMetaData_FOUND)
  target_link_libraries(filelistingtest KF${KF_MAJOR_VERSION}::FileMetaData)
endif(KF${KF_MAJOR_VERSION}FileMetaData_FOUND)
if(Exempi_FOUND)
  target_link_libraries(filelistingtest ${Exempi_LIBRARIES})
endif(Exempi_FOUND)

ecm_add_test(gcstartest.cpp
             ../translators/gcstarimporter.cpp
             ../translators/gcstarexporter.cpp
             ../translators/tellicoxmlexporter.cpp
             ../translators/tellicozipexporter.cpp
             ../translators/exporter.cpp
             ../document.cpp
    TEST_NAME gcstartest
    LINK_LIBRARIES ${TELLICO_TEST_LIBS} translatorstest
)

ecm_add_test(goodreadstest.cpp
             ../translators/goodreadsimporter.cpp
    TEST_NAME goodreadstest
    LINK_LIBRARIES ${TELLICO_TEST_LIBS} translatorstest
)

ecm_add_test(griffithtest.cpp
             ../translators/griffithimporter.cpp
    TEST_NAME griffithtest
    LINK_LIBRARIES ${TELLICO_TEST_LIBS} translatorstest
)

ecm_add_test(htmlexportertest.cpp
             ../translators/htmlexporter.cpp
             ../translators/tellicoxmlexporter.cpp
             ../translators/tellicozipexporter.cpp
             ../translators/exporter.cpp
             ../document.cpp

=== debian/changelog ===
tellico (4.0-1) unstable; urgency=medium

  * New upstream release.
  * Update the build dependencies according to the upstream build system:
    - bump Qt packages to 5.12.0
    - bump KF packages to 5.72.0
    - add libkf5completion-dev, explicitly searched
    - add breeze-icon-theme for FileListingTest, which tries to load a MIME icon
    - drop libkf5wallet-dev, no more used
  * Pass -DBUILD_WITH_QT6=OFF to cmake to keep building with Qt5/KF5 for now.
  * Update the patches:
    - tests-disable-fetchertest.diff: refresh
  * Drop duplicate commas in the Build-Depends control field: it looks like
    newer versions of apt fail to parse them.
  * CI: make the build non-verbose, so the build log fits within the salsa
    limits.
  * Update install files.

 -- Pino Toscano <pino@debian.org>  Sun, 08 Sep 2024 08:25:49 +0200

=== debian/control ===
Source: tellico
Section: kde
Priority: optional
Maintainer: Debian KDE Extras Team <pkg-kde-extras@lists.alioth.debian.org>
Uploaders: Pino Toscano <pino@debian.org>,
Build-Depends: debhelper-compat (= 13)
 , cmake (>= 3.16~), extra-cmake-modules (>= 5.19.0~)
 , pkgconf, pkg-kde-tools, qtbase5-dev (>= 5.12.0~)
 , libqt5charts5-dev (>= 5.12.0~)
 , qtwebengine5-dev (>= 5.12.0~) [amd64 arm64 armhf i386]
 , libkf5archive-dev (>= 5.72.0~)
 , libkf5cddb-dev
 , libkf5codecs-dev (>= 5.72.0~)
 , libkf5completion-dev (>= 5.72.0~)
 , libkf5config-dev (>= 5.72.0~)
 , libkf5configwidgets-dev (>= 5.72.0~)
 , libkf5coreaddons-dev (>= 5.72.0~)
 , libkf5crash-dev (>= 5.72.0~)
 , libkf5doctools-dev (>= 5.72.0~)
 , libkf5filemetadata-dev (>= 5.72.0~)
 , libkf5guiaddons-dev (>= 5.72.0~)
 , libkf5khtml-dev (>= 5.72.0~)
 , libkf5i18n-dev (>= 5.72.0~)
 , libkf5iconthemes-dev (>= 5.72.0~)
 , libkf5itemmodels-dev (>= 5.72.0~)
 , libkf5jobwidgets-dev (>= 5.72.0~)
 , libkf5kio-dev (>= 5.72.0~)
 , libkf5newstuff-dev (>= 5.72.0~)
 , libkf5sane-dev
 , libkf5solid-dev (>= 5.72.0~)
 , libkf5sonnet-dev (>= 5.72.0~)
 , libkf5textwidgets-dev (>= 5.72.0~)
 , libkf5widgetsaddons-dev (>= 5.72.0~)
 , libkf5xmlgui-dev (>= 5.72.0~)
 , libtag1-dev, libyaz-dev, libpoppler-qt5-dev
 , libexempi-dev, libcsv-dev, libbtparse-dev
 , libcdio-dev
 , gettext
 , xvfb <!nocheck>, xauth <!nocheck>, kio <!nocheck>, yaz <!nocheck>
 , python3:any, dh-python
 , dbus <!nocheck>
 , tidy <!nocheck>
 , breeze-icon-theme <!nocheck>
# missing in libtag1-dev
 , zlib1g-dev
# missing in libkf5sane-dev
 , libksanecore-dev
Standards-Version: 4.7.0
Rules-Requires-Root: no
Homepage: https://tellico-project.org/
Vcs-Browser: https://salsa.debian.org/qt-kde-team/extras/tellico
Vcs-Git: https://salsa.debian.org/qt-kde-team/extras/tellico.git

Package: tellico
Architecture: any
Depends: tellico-data (= ${source:Version})
 , tellico-scripts (>= ${source:Version})
 , ${shlibs:Depends}, ${misc:Depends}
Recommends: tellico-doc, kio-extras
Description: Collection manager for books, videos, music, etc
 Tellico is a collection manager for KDE. It includes default collections for
 books, bibliographies, comic books, videos, music, coins, stamps, trading
 cards, and wines.
 .
 Tellico capabilities include:
 .
   * creation of user-defined custom collections with unlimited fields,
   * automatically formatted names,
   * sorting and filtering by any field or property,
   * ISBN validation,
   * full customization for printing or display through XSLT files,
   * import and export of CSV, RIS, BibTeX and BibTeXML files,
   * import data from Amazon, IMDb, CDDB or any US-MARC compliant z39.50 server.
 .
 Tellico files are stored in XML format, avoiding the need for a database
 server, and allowing other software applications to use the data.

Package: tellico-doc
Section: doc
Architecture: all
Depends: ${misc:Depends}
Recommends: tellico, khelpcenter
Description: Collection manager for books, videos, music, etc [doc]
 Tellico is a collection manager for KDE. It includes default collections for
 books, bibliographies, comic books, videos, music, coins, stamps, trading
 cards, and wines.
 .
 Tellico capabilities include:
 .
   * creation of user-defined custom collections with unlimited fields,
   * automatically formatted names,
   * sorting and filtering by any field or property,
   * ISBN validation,
   * full customization for printing or display through XSLT files,
   * import and export of CSV, RIS, BibTeX and BibTeXML files,
   * import data from Amazon, IMDb, CDDB or any US-MARC compliant z39.50 server.
 .
 Tellico files are stored in XML format, avoiding the need for a database
 server, and allowing other software applications to use the data.
 .
 This package contains the documentation.

Package: tellico-data
Architecture: all
Depends: ${misc:Depends}, ${perl:Depends}
Recommends: tellico
Description: Collection manager for books, videos, music, etc [data]
 Tellico is a collection manager for KDE. It includes default collections for
 books, bibliographies, comic books, videos, music, coins, stamps, trading
 cards, and wines.
 .
 Tellico capabilities include:
 .
   * creation of user-defined custom collections with unlimited fields,
   * automatically formatted names,
   * sorting and filtering by any field or property,
   * ISBN validation,
   * full customization for printing or display through XSLT files,
   * import and export of CSV, RIS, BibTeX and BibTeXML files,
   * import data from Amazon, IMDb, CDDB or any US-MARC compliant z39.50 server.
 .
 Tellico files are stored in XML format, avoiding the need for a database
 server, and allowing other software applications to use the data.
 .
 This package contains the architecture independent files, such data files and
 documentation.

Package: tellico-scripts
Architecture: all
Depends: ${misc:Depends}, ${python3:Depends}
Recommends: tellico
Description: Collection manager for books, videos, music, etc [scripts]
 Tellico is a collection manager for KDE. It includes default collections for
 books, bibliographies, comic books, videos, music, coins, stamps, trading
 cards, and wines.
 .
 Tellico capabilities include:
 .
   * creation of user-defined custom collections with unlimited fields,
   * automatically formatted names,
   * sorting and filtering by any field or property,
   * ISBN validation,
   * full customization for printing or display through XSLT files,
   * import and export of CSV, RIS, BibTeX and BibTeXML files,
   * import data from Amazon, IMDb, CDDB or any US-MARC compliant z39.50 server.
 .
 Tellico files are stored in XML format, avoiding the need for a database
 server, and allowing other software applications to use the data.
 .
 This package contains the scripts to import data from external sources, such
 as websites. As the format of the data may change, these scripts are provided
 as a separate package which can be updated through debian-volatile.

=== debian/rules ===
#!/usr/bin/make -f
# Sample debian/rules that uses debhelper.
# GNU copyright 1997 to 1999 by Joey Hess.

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

# The fixfilepath feature causes a build failure, disable it.
export DEB_BUILD_MAINT_OPTIONS = reproducible=-fixfilepath
# do not use kdeinit for kio
export KDE_FORK_SLAVES=1

%:
	dh $@ --with kf5,python3

override_dh_auto_configure:
	dh_auto_configure -Skf5 -- \
		-DBUILD_WITH_QT6=OFF \
		-DENABLE_WEBCAM=false

override_dh_auto_test:
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
	cd obj-* && $(MAKE) install DESTDIR=$(CURDIR)/test_root
	$(eval TESTS_HOME := $(shell mktemp -d --tmpdir tellico-home.XXXXXX))
	mkdir -p "$(TESTS_HOME)/tmp"
	mkdir -p -m 700 "$(TESTS_HOME)/runtime"
	xvfb-run -a --server-args="-screen 0 1024x768x24+32" dbus-run-session dh_auto_test --no-parallel -- XDG_DATA_DIRS=$(CURDIR)/test_root/usr/share:/usr/local/share:/usr/share HOME="$(TESTS_HOME)" TMPDIR="$(TESTS_HOME)/tmp" XDG_RUNTIME_DIR="$(TESTS_HOME)/runtime"
	rm -rf "$(TESTS_HOME)"
endif

execute_after_dh_auto_install:
	# extra copyright notices
	rm -fv debian/tmp/usr/share/tellico/pics/README.*

override_dh_python3:
	dh_python3 -p tellico-scripts --shebang=/usr/bin/python3 /usr/share/tellico/data-sources
